toolchain-shar-relocate.sh: Add error-handling

The relocation script of the SDK doesn't have enough
error handling when replacing host perl with SDK perl
or changing the symlinks. This will add those checks
along with a sanity check of xargs.

[YOCTO #10114]

(From OE-Core rev: c9982dab4cfdd5963d2c2dd4aab99dd6a27fcd1c)

Signed-off-by: Mariano Lopez <mariano.lopez@linux.intel.com>
Signed-off-by: Ross Burton <ross.burton@intel.com>
Signed-off-by: Richard Purdie <richard.purdie@linuxfoundation.org>
This commit is contained in:
Mariano Lopez 2016-09-21 07:54:25 +00:00 committed by Richard Purdie
parent 2a0f4e713a
commit 7a0fbb90a6
1 changed files with 19 additions and 1 deletions

View File

@ -1,3 +1,8 @@
if ! xargs --version > /dev/null 2>&1; then
echo "xargs is required by the relocation script, please install it firts. Abort!"
exit 1
fi
# fix dynamic loader paths in all ELF SDK binaries
native_sysroot=$($SUDO_EXEC cat $env_setup_script |grep 'OECORE_NATIVE_SYSROOT='|cut -d'=' -f2|tr -d '"')
dl_path=$($SUDO_EXEC find $native_sysroot/lib -name "ld-linux*")
@ -7,6 +12,10 @@ if [ "$dl_path" = "" ] ; then
fi
executable_files=$($SUDO_EXEC find $native_sysroot -type f \
\( -perm -0100 -o -perm -0010 -o -perm -0001 \) -printf "'%h/%f' ")
if [ "x$executable_files" = "x" ]; then
echo "SDK relocate failed, could not get executalbe files"
exit 1
fi
tdir=`mktemp -d`
if [ x$tdir = x ] ; then
@ -14,7 +23,7 @@ if [ x$tdir = x ] ; then
exit 1
fi
cat <<EOF >> $tdir/relocate_sdk.sh
#!/bin/bash
#!/bin/sh
for py in python python2 python3
do
PYTHON=\`which \${py} 2>/dev/null\`
@ -53,9 +62,18 @@ done | xargs -n100 file | grep ":.*\(ASCII\|script\|source\).*text" | \
-e "s:^#! */usr/bin/perl.*:#! /usr/bin/env perl:g" \
-e "s: /usr/bin/perl: /usr/bin/env perl:g"
if [ $? -ne 0 ]; then
echo "Failed to replace perl. Relocate script failed. Abort!"
exit 1
fi
# change all symlinks pointing to @SDKPATH@
for l in $($SUDO_EXEC find $native_sysroot -type l); do
$SUDO_EXEC ln -sfn $(readlink $l|$SUDO_EXEC sed -e "s:$DEFAULT_INSTALL_DIR:$target_sdk_dir:") $l
if [ $? -ne 0 ]; then
echo "Failed to setup symlinks. Relocate script failed. Abort!"
exit 1
fi
done
echo done